#include "fat.internals.h"
#include <stdio.h>
#if FAT_FIND_SIMPLE
	bool Fat_FindFileSimple(
			const fat_state_t*		pFS,
			file_handle_t*			hParent,
			const char*				name,
			const uint8_t			attribMask,
			struct fat_direntry*	resultDirEntry,
			file_handle_t*  		hResultFile		// optional
	) {
		uint32_t	address = 0;
		char		fatName[11];
	
		Fat_CanonicalNameToFAT(fatName, name);
		
		while( Fat_GetNextDirEntry( pFS, hParent, &address, resultDirEntry ) ) {
			if( resultDirEntry->Attributes != 0 )
				if( (resultDirEntry->Attributes & attribMask) == 0 )
					continue;		
							
			if( !Fat_MatchName( resultDirEntry->Name, fatName ) )
				continue;
			
			if( hResultFile )
				Fat_DirEntryToHandle( hResultFile, &address, resultDirEntry );
			return true;			
		}
		return false;
	}
	
	bool Fat_MatchName(register const char* fatName, register const char* match) {
		register int c;
		
		for( c = 0; c < 11; c++, fatName++, match++ ) {
			if( *match == '\0' )		// stop matching
				break;
			else if( *match == '?' )	// don't care
				continue;
			/*
			if( match[c] == '*' ) {
				if( c > 7 ) return true;
				c = 7; continue;
			}
			*/
			else if( *match != *fatName )
				return false;
		}
		// all matched
		return true;
	}
#endif
